'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 7 March 2001 update 3960] on 5 July 2001 at 11:50:24 pm'!
"Change Set:		OSProcessV2-3 new changes
Date:			5 July 2001
Author:			David T. Lewis

Changes to be applied to OSProcessV2-3.

Per suggestion from Stephen Pair, adds UnixProcess class>>displayOnXServer: 

Alpha code!! Save your image before calling this method, and please do
not use it on a real Swiki until these changes have a few miles on them.

This change requires adding <sys/Xlib.h> to the includes for the
UnixOSProcessPlugin. I do not really like adding the X dependencies
into the plugin, but the alternative would be more changes to
sqXWindow.c, which is hard to get implemented and distributed.
Guess we will just try it this way for a while.
"!


!UnixOSProcessAccessor methodsFor: 'external process access' stamp: 'dtl 7/4/2001 10:37'!
rename: oldPathString to: newPathString
	"Change the name or location of a file. Answer nil for success, or an error message."

	"OSProcess accessor rename: '/tmp/oldFileName.tmp' to: '/tmp/newFileName.tmp'"

	^ self primErrorMessageAt: (self primRename: oldPathString to: newPathString)
! !

!UnixOSProcessAccessor methodsFor: 'display handling' stamp: 'dtl 7/5/2001 23:21'!
primCanConnectToXDisplay: xDisplayName
	"Open and close a connection to displayName. It the connection was successfully
	opened, answer true; otherwise false. This is intended to check for the ability
	to open an X display prior to actually making the attempt."

	"OSProcess accessor primCanConnectToXDisplay: ':0.0' "
	"OSProcess accessor primCanConnectToXDisplay: ':1' "

	<primitive: 'primitiveCanConnectToXDisplay' module: 'UnixOSProcessPlugin'>
	^ nil

! !

!UnixOSProcessAccessor methodsFor: 'display handling' stamp: 'dtl 7/4/2001 12:39'!
primGetXDisplayName
	"Answer a string containing the name for the X display, or nil if the display was opened
	using the $DISPLAY environment variable. This answers the name of the X display as of
	the time it was last opened, which may be different from the current setting of $DISPLAY."

	"OSProcess accessor primGetXDisplayName"

	<primitive: 'primitiveGetXDisplayName' module: 'UnixOSProcessPlugin'>
	^ nil

! !

!UnixOSProcessAccessor methodsFor: 'display handling' stamp: 'dtl 7/5/2001 09:22'!
primIsConnectedToXServer
	"Answer true if VM is currently connected to an X server."

	"OSProcess accessor primIsConnectedToXServer inspect"
	"| x |
	OSProcess accessor primKillDisplay.
	x _ OSProcess accessor primIsConnectedToXServer.
	OSProcess accessor primOpenXDisplay.
	x inspect"

	<primitive: 'primitiveIsConnectedToXServer' module: 'UnixOSProcessPlugin'>
	^ nil

! !

!UnixOSProcessAccessor methodsFor: 'display handling' stamp: 'dtl 7/4/2001 13:44'!
primSetXDisplayName: aStringOrNil
	"Set the name for the X display for use in the next call to primitiveOpenXDisplay.
	aStringOrNil must be either a String (such as 'myhost:0') or nil, indicating that
	the current value of $DISPLAY should be used."

	"OSProcess accessor primSetXDisplayName: ':0.0' "
	"OSProcess accessor primSetXDisplayName: nil "

	<primitive: 'primitiveSetXDisplayName' module: 'UnixOSProcessPlugin'>
	^ nil

! !


!UnixOSProcessPlugin methodsFor: 'primitives - files' stamp: 'dtl 7/4/2001 22:54'!
primitiveFileProtectionMask
	"Call stat(2) to obtain the file protection mask for a file. Answer an Array of
	four integers representing the protection mask, or answer errno on failure. The
	protection mask is four Integers, each of which may be considered an octal digit
	(0-7), with bit values 4, 2, and 1. The first digit selects the set user ID (4) and set
	group ID (2) and save text image (1) attributes. The second digit selects permissions
	for the user who owns the file: read (4), write (2), and execute (1); the third
	selects permissions for other users in the file's group, with the same values; and
	the fourth for other users not in the file's group, with the same values."

	| path statBuf buffer mode errno result |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'path' declareC: 'char *path'.
	self var: 'statBuf' declareC: 'struct stat *statBuf'.
	self var: 'errno' declareC: 'extern int errno'.

	buffer _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(struct stat)' inSmalltalk: [1000]).
	statBuf _ interpreterProxy arrayValueOf: buffer.
	path _ self transientCStringFromString: (interpreterProxy stackObjectValue: 0).
	mode _ (self cCode: 'stat(path, statBuf)' inSmalltalk: [0]).
	(mode == 0) ifTrue:
			[mode _ self cCode: 'statBuf->st_mode' inSmalltalk: [0].
			result _ interpreterProxy instantiateClass: interpreterProxy classArray indexableSize: 4.
			interpreterProxy
				stObject: result
				at: 4
				put: (interpreterProxy integerObjectOf: (self cCode: 'mode & 07' inSmalltalk: [0])).
			interpreterProxy
				stObject: result
				at: 3
				put: (interpreterProxy integerObjectOf: (self cCode: '(mode & 070) >> 3' inSmalltalk: [0])).
			interpreterProxy
				stObject: result
				at: 2
				put: (interpreterProxy integerObjectOf: (self cCode: '(mode & 0700) >> 6' inSmalltalk: [0])).
			interpreterProxy
				stObject: result
				at: 1
				put: (interpreterProxy integerObjectOf: (self cCode: '(mode & 07000) >> 9' inSmalltalk: [0])).
			interpreterProxy pop: 2; push: result]
		ifFalse:
			[interpreterProxy pop: 2; pushInteger: errno].

! !

!UnixOSProcessPlugin methodsFor: 'primitives - files' stamp: 'dtl 7/4/2001 22:54'!
primitiveFileStat
	"Call stat(2) to obtain the file protection mask for a file. Answer errno on failure,
	or on success answer an array with: UID with: GID with: protectionMask. The	
	protectionMask is an Array of four integers representing the protection mask, or
	answer errno on failure. The protection mask is four Integers, each of which may
	be considered an octal digit (0-7), with bit values 4, 2, and 1. The first digit selects
	the set user ID (4) and set group ID (2) and save text image (1) attributes. The second
	digit selects permissions for the user who owns the file: read (4), write (2), and
	execute (1); the third selects permissions for other users in the file's group, with
	the same values; and the fourth for other users not in the file's group, with the
	same values."

	| path statBuf buffer uid gid mask mode errno result |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'path' declareC: 'char *path'.
	self var: 'statBuf' declareC: 'struct stat *statBuf'.
	self var: 'errno' declareC: 'extern int errno'.

	result _ interpreterProxy
				instantiateClass: interpreterProxy classArray
				indexableSize: 3.
	uid _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(uid_t)' inSmalltalk: [4]).
	gid _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(gid_t)' inSmalltalk: [4]).
	mask _ interpreterProxy
				instantiateClass: interpreterProxy
				classArray indexableSize: 4.
	buffer _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(struct stat)' inSmalltalk: [1000]).
	statBuf _ interpreterProxy arrayValueOf: buffer.
	path _ self transientCStringFromString: (interpreterProxy stackObjectValue: 0).
	mode _ (self cCode: 'stat(path, statBuf)' inSmalltalk: [0]).
	(mode == 0) ifTrue:
			[mode _ self cCode: 'statBuf->st_mode' inSmalltalk: [0].
			interpreterProxy
				stObject: mask
				at: 4
				put: (interpreterProxy integerObjectOf: (self cCode: 'mode & 07' inSmalltalk: [0])).
			interpreterProxy
				stObject: mask
				at: 3
				put: (interpreterProxy integerObjectOf: (self cCode: '(mode & 070) >> 3' inSmalltalk: [0])).
			interpreterProxy
				stObject: mask
				at: 2
				put: (interpreterProxy integerObjectOf: (self cCode: '(mode & 0700) >> 6' inSmalltalk: [0])).
			interpreterProxy
				stObject: mask
				at: 1
				put: (interpreterProxy integerObjectOf: (self cCode: '(mode & 07000) >> 9' inSmalltalk: [0])).
			interpreterProxy
				stObject: result
				at: 3
				put: mask.
			interpreterProxy
				stObject: result
				at: 2
				put: (interpreterProxy integerObjectOf: (self cCode: 'statBuf->st_gid' inSmalltalk: [0])).
			interpreterProxy
				stObject: result
				at: 1
				put: (interpreterProxy integerObjectOf: (self cCode: 'statBuf->st_uid' inSmalltalk: [0])).
			interpreterProxy pop: 2; push: result]
		ifFalse:
			[interpreterProxy pop: 2; pushInteger: errno]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - files' stamp: 'dtl 7/4/2001 23:39'!
primitiveRename
	"Call rename(2) to change the name or location of a file. Answer
	nil for success, or errno on failure."

	| oldPath newPath errno |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'oldPath' declareC: 'char *oldPath'.
	self var: 'newPath' declareC: 'char *newPath'.
	self var: 'errno' declareC: 'extern int errno'.

	newPath _ self transientCStringFromString: (interpreterProxy stackObjectValue: 0).
	oldPath _ self transientCStringFromString: (interpreterProxy stackObjectValue: 1).
	((self cCode: 'rename(oldPath, newPath)' inSmalltalk: [0]) == 0)
		ifTrue: [interpreterProxy pop: 3; push: interpreterProxy nilObject]
		ifFalse: [interpreterProxy pop: 3; pushInteger: errno].

! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:44'!
primitiveSendSigabrtTo: anIntegerPid 
	"Send SIGABRT (abort) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGABRT)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:43'!
primitiveSendSigalrmTo: anIntegerPid 
	"Send SIGALRM (alarm clock) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGALRM)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:43'!
primitiveSendSigchldTo: anIntegerPid
	"Send SIGCHLD (child status has changed, usually death of child) to the OS process
	identified by anIntegerPid. Use an explicit check for isIntegerObject so we can
	return -1 on error (the stackIntegerValue: method answers 1 on error, and 1 is a
	valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGCHLD)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:42'!
primitiveSendSigcontTo: anIntegerPid
	"Send SIGCONT (continue) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGCONT)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:41'!
primitiveSendSighupTo: anIntegerPid
	"Send SIGHUP (hangup) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGHUP)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:41'!
primitiveSendSigintTo: anIntegerPid
	"Send SIGINT (interrupt) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGINT)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:40'!
primitiveSendSigkillTo: anIntegerPid
	"Send SIGKILL (kill, unblockable) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGKILL)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:40'!
primitiveSendSigpipeTo: anIntegerPid
	"Send SIGPIPE (broken pipe) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGPIPE)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:39'!
primitiveSendSigquitTo: anIntegerPid
	"Send SIGQUIT (quit) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGQUIT)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:38'!
primitiveSendSigstopTo: anIntegerPid
	"Send SIGSTOP (stop, unblockable) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGSTOP)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:37'!
primitiveSendSigtermTo: anIntegerPid
	"Send SIGTERM (termination) to the OS process identified by anIntegerPid. Use an explicit
	check for isIntegerObject so we can return -1 on error (the stackIntegerValue: method
	answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGTERM)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:37'!
primitiveSendSigusr1To: anIntegerPid
	"Send SIGUSR1 (User-defined signal 1) to the OS process identified by anIntegerPid. Use
	an explicit check for isIntegerObject so we can return -1 on error (the stackIntegerValue:
	method answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGUSR1)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS signals' stamp: 'dtl 7/5/2001 09:36'!
primitiveSendSigusr2To: anIntegerPid
	"Send SIGUSR2 (User-defined signal 2) to the OS process identified by anIntegerPid. Use
	an explicit check for isIntegerObject so we can return -1 on error (the stackIntegerValue:
	method answers 1 on error, and 1 is a valid pid number)."

	| result pidToSignal |
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow signal sending if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[(interpreterProxy isIntegerObject: (interpreterProxy stackValue: 0))
				ifTrue: 
					[pidToSignal _ interpreterProxy stackIntegerValue: 0.
					result _ self cCode: 'kill(pidToSignal, SIGUSR2)' inSmalltalk: [-1].
					interpreterProxy pop: 2; pushInteger: result]
				ifFalse: [interpreterProxy pop: 2; pushInteger: -1]]! !

!UnixOSProcessPlugin methodsFor: 'primitives - fork and exec' stamp: 'dtl 7/5/2001 09:50'!
primitiveForkAndExec2
	"Fork a child OS process, and do an exec in the child. The parent continues on in
	Smalltalk, and this method answers the pid of the child which was created.

	In this implementation, memory for the argument and environment arrays is allocated
	in the image prior to calling this primitive. This allows us to avoid invoking the
	garbage collector in this primitive (thereby moving the locations of environment
	and argument memory), but comes at the cost of twiddling C pointers here in the
	primitive. An alternative to this whole mess is just to malloc the environment and
	argument vectors, but I think it is a good idea to avoid malloc as much as possible
	so as not to limit future ObjectMemory implementations.

	This primitive replaces #primitiveForkAndExec from earlier versions of the plugin.
	The new name permits backward compatibility for an image running on a VM
	which does not yet have the updated plugin. This implementation uses a different
	argument format on the stack, and differs functionally in that the child now closes
	all file descriptors (including sockets) not required (that is, everything except stdin,
	stdout, and stderr on descriptors 0, 1 and 2). This eliminates some flakey behavior
	in child processes connected to Squeak by pipes, which failed to exit at expected times
	due to the old file descriptors remaining open. This is also cleaner in that garbage
	descriptors are not left hanging around the the child.

	On entry, the stack contains:
		0: envOffsets, an array of integers for calculating environment string address offsets.
		1: envVecBuffer, a String buffer containing environment strings arranged to look like char **.
		2: argOffsets, an array of integers for calculating argument string address offsets.
		3: argVecBuffer, a String buffer containing argument strings arranged to look like char **.
		4: stdErr, a ByteArray handle.
		5: stdOut, a ByteArray handle.
		6: stdIn, a ByteArray handle.
		7: executableFile, a null terminated String with the name of the file to execute.
		8: the sender"

	| progNamePtr argsPtr envPtr intervalTimer saveIntervalTimer envVec handlesToClosePtr pid
	envOffsets envVecBuffer argOffsets argVecBuffer stdErr stdOut stdIn executableFile idx
	handleCount envCount argCount envOffsetPtr argOffsetPtr env args |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'progNamePtr' declareC: 'char *progNamePtr'.
	self var: 'argsPtr' declareC: 'char *argsPtr'.
	self var: 'envPtr' declareC: 'char *envPtr'.
	self var: 'args' declareC: 'char **args'.
	self var: 'env' declareC: 'char **env'.
	self var: 'intervalTimer' declareC: 'struct itimerval intervalTimer'.
	self var: 'saveIntervalTimer' declareC: 'struct itimerval saveIntervalTimer'.
	self var: 'envVec' declareC: 'extern char **envVec'.
	self var: 'handlesToClosePtr' declareC: 'int *handlesToClosePtr'.
	self var: 'envOffsetPtr' declareC: 'int *envOffsetPtr'.
	self var: 'argOffsetPtr' declareC: 'int *argOffsetPtr'.

	self setSigChldHandler.

	"Do not fork child if running in secure mode"
	(self sandboxSecurity == 1) ifTrue: [interpreterProxy pop: 9; pushInteger: -1] ifFalse: [

	"Turn off the interval timer. If this is not done, then the program which we exec in
	the child process will receive a timer interrupt, and will not know how to handle it."
	self cCode: 'intervalTimer.it_interval.tv_sec = 0'.
	self cCode: 'intervalTimer.it_interval.tv_usec = 0'.
	self cCode: 'intervalTimer.it_value.tv_sec = 0'.
	self cCode: 'intervalTimer.it_value.tv_usec = 0'.
	self cCode: 'setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer)'.

	((pid _ self cCode: 'vfork()') = 0)
		ifFalse:
			[ "Normal return to Smalltalk - this is the old parent process."
			"Enable the timer again before resuming Smalltalk."
			self cCode: 'setitimer (ITIMER_REAL, &saveIntervalTimer, 0L)'.
			interpreterProxy pop: 9; pushInteger: pid 
			"Pop 8 arguments plus receiver, push pid."]
		ifTrue:
			[ "This is the new child process"
			envOffsets _ interpreterProxy stackObjectValue: 0.
			envVecBuffer _ interpreterProxy stackObjectValue: 1.
			argOffsets _ interpreterProxy stackObjectValue: 2.
			argVecBuffer _ interpreterProxy stackObjectValue: 3.
			stdErr _ interpreterProxy stackObjectValue: 4.
			stdOut _ interpreterProxy stackObjectValue: 5.
			stdIn _ interpreterProxy stackObjectValue: 6.
			executableFile _ interpreterProxy stackObjectValue: 7.

			"Pointer to name of the file to execute."
			progNamePtr _ interpreterProxy arrayValueOf: executableFile.

			"Dup the file handles to attach the new child process to the right streams
			on descriptors 0, 1 and 2."
			(stdErr = interpreterProxy nilObject) ifFalse: [self dupToStdErr: stdErr].
			(stdOut = interpreterProxy nilObject) ifFalse: [self dupToStdOut: stdOut].
			(stdIn = interpreterProxy nilObject) ifFalse: [self dupToStdIn: stdIn].

			"Close all file handles not needed by the child. This is done by brute force
			because the image has no way of being aware of all open file descriptors
			(some are opened by the VM without the knowledge of the image)."
			idx _ 3.	"First Unix file descriptor after stdin, stdout, stderr."
			handleCount _ self descriptorTableSize.
			[idx < handleCount]
				whileTrue:
					[self cCode: 'close(idx)'.
					idx _ idx + 1].

			"Set up the environment, a C array of pointers to C strings, where each string
			is of the form 'KEY=value'. Refer to previously allocated object memory rather
			than using a call to malloc()."
			envVecBuffer = (interpreterProxy nilObject)
				ifTrue:
					[env _ envVec]
				ifFalse:
					[envCount _ interpreterProxy stSizeOf: envOffsets.
					envPtr _ interpreterProxy arrayValueOf: envVecBuffer.
					envOffsetPtr _ interpreterProxy firstIndexableField: envOffsets.
					self
						fixPointersInArrayOfStrings: envPtr
						withOffsets: envOffsetPtr
						count: envCount.
					env _ self cCoerce: envPtr to: 'char **'].

			"Set up the argument array. Allocate space for a C array of pointers to strings.
			Reer to previously allocated object memory rather than using a call to malloc()."
			argCount _ interpreterProxy stSizeOf: argOffsets.
			argsPtr _ interpreterProxy arrayValueOf: argVecBuffer.
			argOffsetPtr _ interpreterProxy firstIndexableField: argOffsets.
			self
				fixPointersInArrayOfStrings: argsPtr
				withOffsets: argOffsetPtr
				count: argCount.
			args _ self cCoerce: argsPtr to: 'char **'.

			"Clean things up before clobbering the running image."
			"Release shared memory for bitmap, if any. This is specific to the Unix/X
			version of Squeak."
			self cCode: '
#ifdef USE_XSHM
		(void *) shmExit();
#endif
		/* Extra semicolon here is an artifact of Squeak C translation */	'.

			"Note: If any file descriptors, signal handlers, or other references to external
			resources need to be cleaned up, do it here."
			self restoreDefaultSignalHandlers.

			"Do the exec to overlay the new program on this child address space. This is 
			the end of the world as we know it."
			(self cCode: 'execve(progNamePtr, args, env)' ) = -1
				ifTrue:
					[self cCode: 'perror(progNamePtr)'; cCode: 'exit(-1)' "execve() error, child exits"]
				ifFalse:
					[self cCode: '/* Can''t get here from there */']]]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - fork and exec' stamp: 'dtl 7/5/2001 09:49'!
primitiveForkAndExecClosingAll
	"Fork a child OS process, and do an exec in the child. The parent continues on in
	Smalltalk, and this method answers the pid of the child which was created.

	This primitive replaces #primitiveForkAndExec from earlier versions of the plugin.
	The new name permits backward compatibility for an image running on a VM
	which does not yet have the updated plugin. This implementation uses a different
	argument format on the stack, and differs functionally in that the child now closes
	all file descriptors (including sockets) not required (that is, everything except stdin,
	stdout, and stderr on descriptors 0, 1 and 2). This eliminates some flakey behavior
	in child processes connected to Squeak by pipes, which failed to exit at expected times
	due to the old file descriptors remaining open. This is also cleaner in that garbage
	descriptors are not left hanging around the the child.

	On entry, the stack contains:
		0:	stderr handle, a ByteArray
		1:	stdout handle, a ByteArray
		2:	stdin handle, aByteArray
		3:	environment, either nil or an array of null terminated strings
		4:	args, an array of null terminated strings
		5:	program name, a null terminated string
		6:	the sender"

	| pid argCount args argsPtr argHolder progNamePtr
	env envPtr envHolder envVec envCount idx intervalTimer saveIntervalTimer handleCount |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'progNamePtr' declareC: 'char *progNamePtr'.
	self var: 'argsPtr' declareC: 'char **argsPtr'.
	self var: 'envPtr' declareC: 'char **envPtr'.
	self var: 'intervalTimer' declareC: 'struct itimerval intervalTimer'.
	self var: 'saveIntervalTimer' declareC: 'struct itimerval saveIntervalTimer'.
	self var: 'envVec' declareC: 'extern char **envVec'.
	self var: 'handlesToClosePtr' declareC: 'int *handlesToClosePtr'.
	self setSigChldHandler.

	"Do not fork child if running in secure mode"
	(self sandboxSecurity == 1) ifTrue: [interpreterProxy pop: 7; pushInteger: -1] ifFalse: [

	"Turn off the interval timer. If this is not done, then the program which we exec in
	the child process will receive a timer interrupt, and will not know how to handle it."
	self cCode: 'intervalTimer.it_interval.tv_sec = 0'.
	self cCode: 'intervalTimer.it_interval.tv_usec = 0'.
	self cCode: 'intervalTimer.it_value.tv_sec = 0'.
	self cCode: 'intervalTimer.it_value.tv_usec = 0'.
	self cCode: 'setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer)'.

	((pid _ self cCode: 'vfork()') = 0)
		ifFalse: [ "Normal return to Smalltalk - this is the old parent process."
				"Enable the timer again before resuming Smalltalk."
				self cCode: 'setitimer (ITIMER_REAL, &saveIntervalTimer, 0L)'.
				interpreterProxy pop: 7; pushInteger: pid 
				"Pop 6 arguments plus receiver, push pid."]
		ifTrue: [ "This is the new child process"
			env _ interpreterProxy stackObjectValue: 3.
			args _ interpreterProxy stackObjectValue: 4.

			"Dup the file handles to attach the new child process to the right streams
			on descriptors 0, 1 and 2."
			((interpreterProxy stackObjectValue: 0) = interpreterProxy nilObject)
				ifFalse: [ self dupToStdErr: (interpreterProxy stackObjectValue: 0) ].
			((interpreterProxy stackObjectValue: 1) = interpreterProxy nilObject)
				ifFalse: [ self dupToStdOut: (interpreterProxy stackObjectValue: 1) ].
			((interpreterProxy stackObjectValue: 2) = interpreterProxy nilObject)
				ifFalse: [ self dupToStdIn: (interpreterProxy stackObjectValue: 2) ].

			"Close all file handles not needed by the child. This is done by brute
			force because the image has no way of being aware of all open file
			descriptors (some are opened by the VM without the knowledge of the
			image)."
			idx _ 3.	"First Unix file descriptor after stdin, stdout, stderr."
			handleCount _ self descriptorTableSize.
			[idx < handleCount]
				whileTrue:
					[self cCode: 'close(idx)'.
					idx _ idx + 1].

			"Set up the environment, a C array of pointers to C strings, where each
			string is of the form 'KEY=value'. Use object memory rather than a call
			to malloc(). If a new environment array is allocated, the pointer copying
			will be done later, right before doing the execve() call."
			env = (interpreterProxy nilObject)
				ifTrue: [ envPtr _ envVec ]
				ifFalse: [
					"Allocate space for a C array of pointers to strings. Use object
					memory rather than a call to malloc()."
					envCount _ interpreterProxy stSizeOf: env.
					envHolder _ interpreterProxy
						instantiateClass: interpreterProxy classByteArray
						indexableSize: (envCount + 1) * 4].

			"Set up the argument array. Allocate space for a C array of pointers to strings.
			Use object memory rather than a call to malloc(). The pointer copying will be
			done later, right before doing the execve() call."
			argCount _ interpreterProxy stSizeOf: args.
			argHolder _ interpreterProxy
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (argCount + 1) * 4.

			"Clean things up before clobbering the running image."
			"Release shared memory for bitmap, if any. This is specific to the Unix/X
			version of Squeak."
			self cCode: '
#ifdef USE_XSHM
		(void *) shmExit();
#endif
		/* Extra semicolon here is an artifact of Squeak C translation */	'.

			"If we have allocated a new environment array, copy the pointers now.
			This is done as late as possible so as not to invoke the garbage collector
			after the pointers have been copied."
			env = (interpreterProxy nilObject)
				ifFalse: [
					idx  _ 1.
					[ idx <= envCount ] whileTrue: [
						envPtr
							at: idx - 1
							put: (interpreterProxy arrayValueOf: (interpreterProxy
																	stObject: env
																	at: idx)).
						idx _ idx + 1 ].
					envPtr at: idx put: 0.	"Null terminate the list of pointers to strings" ].

			"Copy the pointers for the argument array. This is done as late as possible so
			as not to invoke the garbage collector after the pointers have been copied."
			argsPtr _ interpreterProxy arrayValueOf: argHolder.
			idx  _ 1.
			[ idx <= argCount ] whileTrue: [
				argsPtr
					at: idx - 1
					put: (interpreterProxy arrayValueOf: (interpreterProxy
															stObject: args
															at: idx)).
				idx _ idx + 1 ].
			argsPtr at: idx put: 0.	"Null terminate the list of pointers to strings".

			progNamePtr _ interpreterProxy arrayValueOf: (interpreterProxy stackObjectValue: 5).

			"Note: If any file descriptors, signal handlers, or other references to external
			resources need to be cleaned up, do it here."
			self restoreDefaultSignalHandlers.

			"Do the exec to overlay the new program on this child address space. This is 
			the end of the world as we know it."
			(self cCode: 'execve(progNamePtr, argsPtr, envPtr)' ) = -1
				ifTrue:
					[self cCode: 'perror(progNamePtr)'; cCode: 'exit(-1)' "execve() error, child exits"]
				ifFalse:
					[self cCode: '/* Can''t get here from there */']]]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - fork and exec' stamp: 'dtl 7/5/2001 09:48'!
primitiveForkAndExecInDirectory
	"Fork a child OS process, and do an exec in the child. The parent continues on in
	Smalltalk, and this method answers the pid of the child which was created.

	In this implementation, memory for the argument and environment arrays is allocated
	in the image prior to calling this primitive. This allows us to avoid invoking the
	garbage collector in this primitive (thereby moving the locations of environment
	and argument memory), but comes at the cost of twiddling C pointers here in the
	primitive. An alternative to this whole mess is just to malloc the environment and
	argument vectors, but I think it is a good idea to avoid malloc as much as possible
	so as not to limit future ObjectMemory implementations.

	This primitive replaces #primitiveForkAndExec from earlier versions of the plugin.
	The new name permits backward compatibility for an image running on a VM
	which does not yet have the updated plugin. This implementation uses a different
	argument format on the stack, and differs functionally in that the child now closes
	all file descriptors (including sockets) not required (that is, everything except stdin,
	stdout, and stderr on descriptors 0, 1 and 2). This eliminates some flakey behavior
	in child processes connected to Squeak by pipes, which failed to exit at expected times
	due to the old file descriptors remaining open. This is also cleaner in that garbage
	descriptors are not left hanging around the the child.

	On entry, the stack contains:
		0: workingDir, a null terminated string specifying the working directory to use, or nil.
		1: envOffsets, an array of integers for calculating environment string address offsets.
		2: envVecBuffer, a String buffer containing environment strings arranged to look like char **.
		3: argOffsets, an array of integers for calculating argument string address offsets.
		4: argVecBuffer, a String buffer containing argument strings arranged to look like char **.
		5: stdErr, a ByteArray handle.
		6: stdOut, a ByteArray handle.
		7: stdIn, a ByteArray handle.
		8: executableFile, a null terminated string with the name of the file to execute.
		9: the sender"

	| progNamePtr argsPtr envPtr intervalTimer saveIntervalTimer envVec handlesToClosePtr pid
	envOffsets envVecBuffer argOffsets argVecBuffer stdErr stdOut stdIn executableFile idx
	handleCount envCount argCount envOffsetPtr argOffsetPtr workingDir pwdPtr pwd env args |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'progNamePtr' declareC: 'char *progNamePtr'.
	self var: 'argsPtr' declareC: 'char *argsPtr'.
	self var: 'envPtr' declareC: 'char *envPtr'.
	self var: 'args' declareC: 'char **args'.
	self var: 'env' declareC: 'char **env'.
	self var: 'pwdPtr' declareC: 'char *pwdPtr'.
	self var: 'intervalTimer' declareC: 'struct itimerval intervalTimer'.
	self var: 'saveIntervalTimer' declareC: 'struct itimerval saveIntervalTimer'.
	self var: 'envVec' declareC: 'extern char **envVec'.
	self var: 'handlesToClosePtr' declareC: 'int *handlesToClosePtr'.
	self var: 'envOffsetPtr' declareC: 'int *envOffsetPtr'.
	self var: 'argOffsetPtr' declareC: 'int *argOffsetPtr'.

	self setSigChldHandler.

	"Do not fork child if running in secure mode"
	(self sandboxSecurity == 1) ifTrue: [interpreterProxy pop: 10; pushInteger: -1] ifFalse: [

	"Turn off the interval timer. If this is not done, then the program which we exec in
	the child process will receive a timer interrupt, and will not know how to handle it."
	self cCode: 'intervalTimer.it_interval.tv_sec = 0'.
	self cCode: 'intervalTimer.it_interval.tv_usec = 0'.
	self cCode: 'intervalTimer.it_value.tv_sec = 0'.
	self cCode: 'intervalTimer.it_value.tv_usec = 0'.
	self cCode: 'setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer)'.

	((pid _ self cCode: 'vfork()') = 0)
		ifFalse:
			[ "Normal return to Smalltalk - this is the old parent process."
			"Enable the timer again before resuming Smalltalk."
			self cCode: 'setitimer (ITIMER_REAL, &saveIntervalTimer, 0L)'.
			interpreterProxy pop: 10; pushInteger: pid 
			"Pop 9 arguments plus receiver, push pid."]
		ifTrue:
			[ "This is the new child process"
			workingDir _ interpreterProxy stackObjectValue: 0.
			envOffsets _ interpreterProxy stackObjectValue: 1.
			envVecBuffer _ interpreterProxy stackObjectValue: 2.
			argOffsets _ interpreterProxy stackObjectValue: 3.
			argVecBuffer _ interpreterProxy stackObjectValue: 4.
			stdErr _ interpreterProxy stackObjectValue: 5.
			stdOut _ interpreterProxy stackObjectValue: 6.
			stdIn _ interpreterProxy stackObjectValue: 7.
			executableFile _ interpreterProxy stackObjectValue: 8.

			"If a new working directory has been specified, try to chdir() to it."
			(workingDir ~= interpreterProxy nilObject)
				ifTrue:
					[pwdPtr _ interpreterProxy firstIndexableField: workingDir.
					(pwdPtr == 0)
						ifTrue:
							[self cCode: 'fprintf(stderr, "bad workingDir parameter\n")'.
							self cCode: 'exit(-1)']
						ifFalse:
							[pwd _ self cCode: 'chdir(pwdPtr)' inSmalltalk: [0].
							(pwd ~= 0)
								ifTrue:
									[self cCode: 'perror("chdir")'.
									self cCode: 'exit(-1)']]].

			"Pointer to name of the file to execute."
			progNamePtr _ interpreterProxy arrayValueOf: executableFile.

			"Dup the file handles to attach the new child process to the right streams
			on descriptors 0, 1 and 2."
			(stdErr = interpreterProxy nilObject) ifFalse: [self dupToStdErr: stdErr].
			(stdOut = interpreterProxy nilObject) ifFalse: [self dupToStdOut: stdOut].
			(stdIn = interpreterProxy nilObject) ifFalse: [self dupToStdIn: stdIn].

			"Close all file handles not needed by the child. This is done by brute force
			because the image has no way of being aware of all open file descriptors
			(some are opened by the VM without the knowledge of the image)."
			idx _ 3.	"First Unix file descriptor after stdin, stdout, stderr."
			handleCount _ self descriptorTableSize.
			[idx < handleCount]
				whileTrue:
					[self cCode: 'close(idx)'.
					idx _ idx + 1].

			"Set up the environment, a C array of pointers to C strings, where each string
			is of the form 'KEY=value'. Refer to previously allocated object memory rather
			than using a call to malloc()."
			envVecBuffer = (interpreterProxy nilObject)
				ifTrue:
					[env _ envVec]
				ifFalse:
					[envCount _ interpreterProxy stSizeOf: envOffsets.
					envPtr _ interpreterProxy arrayValueOf: envVecBuffer.
					envOffsetPtr _ interpreterProxy firstIndexableField: envOffsets.
					self
						fixPointersInArrayOfStrings: envPtr
						withOffsets: envOffsetPtr
						count: envCount.
					env _ self cCoerce: envPtr to: 'char **'].

			"Set up the argument array. Allocate space for a C array of pointers to strings.
			Reer to previously allocated object memory rather than using a call to malloc()."
			argCount _ interpreterProxy stSizeOf: argOffsets.
			argsPtr _ interpreterProxy arrayValueOf: argVecBuffer.
			argOffsetPtr _ interpreterProxy firstIndexableField: argOffsets.
			self
				fixPointersInArrayOfStrings: argsPtr
				withOffsets: argOffsetPtr
				count: argCount.
			args _ self cCoerce: argsPtr to: 'char **'.

			"Clean things up before clobbering the running image."
			"Release shared memory for bitmap, if any. This is specific to the Unix/X
			version of Squeak."
			self cCode: '
#ifdef USE_XSHM
		(void *) shmExit();
#endif
		/* Extra semicolon here is an artifact of Squeak C translation */	'.

			"Note: If any file descriptors, signal handlers, or other references to external
			resources need to be cleaned up, do it here."
			self restoreDefaultSignalHandlers.

			"Do the exec to overlay the new program on this child address space. This is 
			the end of the world as we know it."
			(self cCode: 'execve(progNamePtr, args, env)' ) = -1
				ifTrue:
					[self cCode: 'perror(progNamePtr)'; cCode: 'exit(-1)' "execve() error, child exits"]
				ifFalse:
					[self cCode: '/* Can''t get here from there */']]]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - fork and exec' stamp: 'dtl 7/5/2001 09:47'!
primitiveForkHeadlessSqueak
	"Fork a child process, and continue running squeak in the child process. Leave the
	X session connected to the parent process, but close its file descriptor for the child
	process. Do not open another X session for the child. The child is expected to avoid
	any further interaction with the screen, otherwise the child process will fail.

	The child should not depend on using existing connections to external resources. For
	example, the child may lose its connections to stdin, stdout, and stderr after its parent
	exits."

	| pid intervalTimer saveIntervalTimer synchronizeXDisplay forgetXDisplay|
	self export: true.
	self returnTypeC: 'void'.
	self var: 'intervalTimer' declareC: 'struct itimerval intervalTimer'.
	self var: 'saveIntervalTimer' declareC: 'struct itimerval saveIntervalTimer'.
	self var: 'synchronizeXDisplay' declareC: 'extern int synchronizeXDisplay()'.
	self var: 'forgetXDisplay' declareC: 'extern int forgetXDisplay()'.

	"Do not fork child if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 1; pushInteger: -1]
		ifFalse:
			["Turn off the interval timer. If this is not done, then the program which we exec in
			the child process will receive a timer interrupt, and will not know how to handle it."
			self cCode: 'intervalTimer.it_interval.tv_sec = 0'.
			self cCode: 'intervalTimer.it_interval.tv_usec = 0'.
			self cCode: 'intervalTimer.it_value.tv_sec = 0'.
			self cCode: 'intervalTimer.it_value.tv_usec = 0'.
			self cCode: 'setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer)'.
			self cCode: 'synchronizeXDisplay()'.
			self setSigChldHandler.
			pid _ self cCode: 'fork()'.
			pid = 0 ifTrue: [ "I am the child process"
				self cCode: 'forgetXDisplay()'.
				self cCode: '/* Child process does not yet have its own window, so we just */'.
				self cCode: '/* need to forget about the parent''s window here. */' ].

			"Enable the timer again before resuming Smalltalk."
			self cCode: 'setitimer (ITIMER_REAL, &saveIntervalTimer, 0L)'.
			interpreterProxy pop: 1; pushInteger: pid]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - fork and exec' stamp: 'dtl 7/5/2001 09:46'!
primitiveForkSqueak
	"Fork a child process, and continue running squeak in the child process. After calling
	fork(), two OS processes exist, one of which is the child of the other. On systems
	which implement copy-on-write memory management, and which support the fork()
	system call, both processes will be running Smalltalk images, and will be sharing the
	same memory space. In the original OS process, the resulting value of pid is the process
	id of the child process (a non-zero integer). In the child process, the value of pid is zero.

	The child recreates sufficient external resources to continue running. This is done by
	attaching to a new X session. The child is otherwise a copy of the parent process, and
	will continue executing the Smalltalk image at the same point as its parent. The return
	value of this primitive may be used by the two running Smalltalk images to determine
	which is the parent and which is the child.

	The child should not depend on using existing connections to external resources. For
	example, the child may lose its connections to stdin, stdout, and stderr after its parent
	exits.

	The new child image does not start itself from the image in the file system; rather it is
	a clone of the parent image as it existed at the time of primitiveForkSqueak. For this
	reason, the parent and child should agree in advance as to whom is allowed to save the
	image to the file system, otherwise one Smalltalk may overwrite the image of the other.

	This is a simple call to fork(), rather than the more common idiom of vfork() followed
	by exec(). The vfork() call cannot be used here because it is designed to be followed by
	an exec(), and its semantics require the parent process to wait for the child to exit. See
	the BSD programmers documentation for details."

	| pid intervalTimer saveIntervalTimer synchronizeXDisplay forgetXDisplay openXDisplay|
	self export: true.
	self returnTypeC: 'void'.
	self var: 'intervalTimer' declareC: 'struct itimerval intervalTimer'.
	self var: 'saveIntervalTimer' declareC: 'struct itimerval saveIntervalTimer'.
	self var: 'synchronizeXDisplay' declareC: 'extern int synchronizeXDisplay()'.
	self var: 'forgetXDisplay' declareC: 'extern int forgetXDisplay()'.
	self var: 'openXDisplay' declareC: 'extern int openXDisplay()'.

	"Do not fork child if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 1; pushInteger: -1]
		ifFalse:
			["Turn off the interval timer. If this is not done, then the program which we exec in
			the child process will receive a timer interrupt, and will not know how to handle it."
			self cCode: 'intervalTimer.it_interval.tv_sec = 0'.
			self cCode: 'intervalTimer.it_interval.tv_usec = 0'.
			self cCode: 'intervalTimer.it_value.tv_sec = 0'.
			self cCode: 'intervalTimer.it_value.tv_usec = 0'.
			self cCode: 'setitimer (ITIMER_REAL, &intervalTimer, &saveIntervalTimer)'.
			self cCode: 'synchronizeXDisplay()'.
			self setSigChldHandler.
			pid _ self cCode: 'fork()'.
			pid = 0 ifTrue: [ "I am the child process"
				self cCode: 'forgetXDisplay()'.
				self cCode: 'openXDisplay()' ].

			"Enable the timer again before resuming Smalltalk."
			self cCode: 'setitimer (ITIMER_REAL, &saveIntervalTimer, 0L)'.
			interpreterProxy pop: 1; pushInteger: pid]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS process access' stamp: 'dtl 7/4/2001 22:53'!
primitiveChdir
	"Call chdir(2) to change current working directory to the specified path string. Answer
	nil for success, or errno on failure."

	| path errno |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'path' declareC: 'char *path'.
	self var: 'errno' declareC: 'extern int errno'.

	path _ self transientCStringFromString: (interpreterProxy stackObjectValue: 0).
	((self cCode: 'chdir(path)' inSmalltalk: [0]) == 0)
		ifTrue: [interpreterProxy pop: 2; push: interpreterProxy nilObject]
		ifFalse: [interpreterProxy pop: 2; pushInteger: errno].

! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS process access' stamp: 'dtl 7/4/2001 22:53'!
primitiveEnvironmentAtSymbol
	"Answer the value of an environment variable keyed by a Symbol."

	| keyCStringPtr getenvResult s |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'keyCStringPtr' declareC: 'char *keyCStringPtr'.
	self var: 'getenvResult' declareC: 'char * getenvResult'.

	keyCStringPtr _ self transientCStringFromString: (interpreterProxy stackObjectValue: 0).
	getenvResult _ self cCode: 'getenv(keyCStringPtr)' inSmalltalk: [0].
	(getenvResult = 0)
		ifTrue:
			[interpreterProxy primitiveFail; pop: 2; push: interpreterProxy nilObject]
		ifFalse:
			[s _ self stringFromCString: getenvResult.
			interpreterProxy pop: 2; push: s]

! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS process access' stamp: 'dtl 7/4/2001 21:08'!
primitiveGetCurrentWorkingDirectory
	"Answer a string containing the current working directory."

	| cwd cwdString bufferSize incrementBy maxSize buffer |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'buffer' declareC: 'char *buffer'.
	self var: 'cwd' declareC: 'char *cwd'.

	bufferSize _ 100.
	incrementBy _ 100.
	maxSize _ 5000.

	[cwdString _ interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: bufferSize.
	buffer _ interpreterProxy arrayValueOf: cwdString.
	cwd _ self cCode: 'getcwd(buffer, bufferSize)' inSmalltalk: [''].
	((cwd == 0)
		and: [bufferSize < maxSize])]
			whileTrue:
				[bufferSize _ bufferSize + incrementBy].
	(cwd == 0)
		ifTrue:
			[interpreterProxy primitiveFail; pop: 1; push: interpreterProxy nilObject]
		ifFalse:
			[cwdString _ self stringFromCString: cwd.
			interpreterProxy pop: 1; push: cwdString]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS process access' stamp: 'dtl 7/4/2001 23:32'!
primitivePutEnv
	"Set an environment variable using a string of the form 'KEY=value'. This
	implementation allocates a C string in object memory (as opposed to using
	malloc to allocate from the C heap). My assumption here is that the C runtime
	library makes a copy of this string into separately allocated environment
	memory. This appears to be the case for Linux, but if my assumption proves
	wrong on other systems, then change this method to call cStringFromString
	rather than transientCStringFromString. I prefer to avoid calling malloc
	as much as possible, hence this implementation choice. -dtl"

	| cStringPtr keyValueString |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'cStringPtr' declareC: 'char *cStringPtr'.
	keyValueString _ interpreterProxy stackObjectValue: 0.
	cStringPtr _ self transientCStringFromString: keyValueString.
	((self cCode: 'putenv(cStringPtr)') = 0)	"Set environment variable."
		ifTrue:
			[interpreterProxy pop: 2; push: keyValueString]
		ifFalse:
			[interpreterProxy primitiveFail; pop: 2; push: interpreterProxy nilObject]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - OS process access' stamp: 'dtl 7/4/2001 22:55'!
primitiveRealpath
	"Answer the real path for a path string as determined by realpath()."

	|  bufferSize pathString newPathString buffer realpathResult s |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'pathString' declareC: 'char *pathString'.
	self var: 'buffer' declareC: 'char *buffer'.
	self var: 'realpathResult' declareC: 'char * realpathResult'.

	bufferSize _ 512.
	pathString _ self transientCStringFromString: (interpreterProxy stackObjectValue: 0).
	newPathString _ interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: bufferSize.
	buffer _ interpreterProxy arrayValueOf: newPathString.
	realpathResult _ self cCode: 'realpath(pathString, buffer)' inSmalltalk: [''].
	(realpathResult = 0)
		ifTrue:
			[interpreterProxy primitiveFail; pop: 2; push: interpreterProxy nilObject]
		ifFalse:
			[s _ self stringFromCString: realpathResult.
			interpreterProxy pop: 2; push: s]

! !

!UnixOSProcessPlugin methodsFor: 'primitives - display' stamp: 'dtl 7/5/2001 23:09'!
primitiveCanConnectToXDisplay
	"Open and close a connection to displayName. It the connection was successfully
	opened, answer true; otherwise false. This is intended to check for the ability
	to open an X display prior to actually making the attempt."

	| name namePtr d |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'namePtr' declareC: 'char * namePtr'.
	self var: 'nameBuffer' declareC: 'static char nameBuffer[501]'.
	self var: 'd' declareC: 'Display *d'.

	"Do not allow this if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; push: interpreterProxy falseObject]
		ifFalse:
			[name _ interpreterProxy stackObjectValue: 0.
			namePtr _ self transientCStringFromString: name.
			d _ self cCode: 'XOpenDisplay(namePtr)'.
			(d == 0)
				ifTrue:	"Failed to make connection to server, answer false"
					[interpreterProxy pop: 2; push: interpreterProxy falseObject]
				ifFalse:	"Successfully opened connection; close it and answer true"
					[self cCode: 'XCloseDisplay(d)'.
					interpreterProxy pop: 2; push: interpreterProxy trueObject]]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - display' stamp: 'dtl 7/4/2001 13:14'!
primitiveGetXDisplayName
	"Answer a string containing the name for the X display, or nil if the display was opened
	using the $DISPLAY environment variable. This answers the name of the X display as of
	the time it was last opened, which may be different from the current setting of $DISPLAY."

	| displayName |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'displayName' declareC: 'extern char *displayName'.
	((displayName == 0)
		ifTrue: [interpreterProxy pop: 1; push: (interpreterProxy nilObject)]
		ifFalse: [interpreterProxy pop: 1; push: (self stringFromCString: displayName)])
! !

!UnixOSProcessPlugin methodsFor: 'primitives - display' stamp: 'dtl 7/5/2001 09:14'!
primitiveIsConnectedToXServer
	"Answer true if VM is currently connected to an X server."

	| isConnectedToXServer |
	self var: 'isConnectedToXServer' declareC: 'extern int isConnectedToXServer'.
	self export: true.
	self returnTypeC: 'void'.
	(isConnectedToXServer ~= 0)
		ifTrue: [interpreterProxy pop: 1; push: (interpreterProxy trueObject)]
		ifFalse: [interpreterProxy pop: 1; push: (interpreterProxy falseObject)]
! !

!UnixOSProcessPlugin methodsFor: 'primitives - display' stamp: 'dtl 7/5/2001 09:33'!
primitiveKillDisplay
	"Call an internal function which will disconnect the X display session."

	| disconnectXDisplay |
	self var: 'disconnectXDisplay' declareC: 'extern int disconnectXDisplay()'.
	self export: true.
	self returnTypeC: 'void'.

	"Do not allow this if running in secure mode"
	(self sandboxSecurity == 1)
		ifFalse: [self cCode: 'disconnectXDisplay()']
! !

!UnixOSProcessPlugin methodsFor: 'primitives - display' stamp: 'dtl 7/5/2001 09:30'!
primitiveOpenXDisplay
	"Call an internal function which will open the X display session."

	| openXDisplay |
	self var: 'openXDisplay' declareC: 'extern int openXDisplay()'.
	self export: true.
	self returnTypeC: 'void'.
	"Do not allow this if running in secure mode"
	(self sandboxSecurity == 1)
		ifFalse: [self cCode: 'openXDisplay()']
! !

!UnixOSProcessPlugin methodsFor: 'primitives - display' stamp: 'dtl 7/5/2001 14:10'!
primitiveSetXDisplayName
	"Set the name for the X display for use in the next call to primitiveOpenXDisplay. Expects
	one parameter which must be either a String or nil."

	| displayName name namePtr nameBuffer |
	self export: true.
	self returnTypeC: 'void'.
	self var: 'namePtr' declareC: 'char * namePtr'.
	self var: 'nameBuffer' declareC: 'static char nameBuffer[501]'.
	self var: 'displayName' declareC: 'extern char *displayName'.
	"Do not allow this if running in secure mode"
	(self sandboxSecurity == 1)
		ifTrue:
			[interpreterProxy pop: 2; pushInteger: -1]
		ifFalse:
			[name _ interpreterProxy stackObjectValue: 0.
			(name == interpreterProxy nilObject)
				ifTrue:
					[displayName _ 0]
				ifFalse:
					[namePtr _ self transientCStringFromString: name.
					self cCode: 'strncpy(nameBuffer, namePtr, 500)'.
					nameBuffer at: 500 put: 0.
					displayName _ nameBuffer].
			interpreterProxy pop: 1]
! !

!UnixOSProcessPlugin methodsFor: 'private' stamp: 'dtl 7/4/2001 23:22'!
cStringFromString: aString
	"Answer a new null-terminated C string copied from aString. The C string
	is allocated from the C runtime heap. See transientCStringFromString for
	a version which allocates from object memory.
	Caution: This may invoke the garbage collector."

	| len sPtr cString |
	self returnTypeC: 'char *'.
	self var: 'sPtr' declareC: 'char *sPtr'.
	self var: 'cString' declareC: 'char *cString'.
	sPtr _ interpreterProxy arrayValueOf: aString.
	len _ interpreterProxy sizeOfSTArrayFromCPrimitive: sPtr.
	cString _ self callocWrapper: len + 1 size: 1.			"Space for a null terminated C string."
	self cCode: '(char *) strncpy (cString, sPtr, len)'.	"Copy the string."
	^ cString
! !

!UnixOSProcessPlugin methodsFor: 'private' stamp: 'dtl 7/4/2001 23:23'!
callocWrapper: count size: objectSize
	"Using malloc() and calloc() is something I would like to avoid, since it is
	likely to cause problems some time in the future if somebody redesigns
	object memory allocation. This wrapper just makes it easy to find senders
	of calloc() in my code. -dtl"

	self returnTypeC: 'void *'.
	^ self cCode: 'calloc(count, objectSize)'! !

!UnixOSProcessPlugin methodsFor: 'private' stamp: 'dtl 7/4/2001 23:23'!
mallocWrapper: size
	"Using malloc() and calloc() is something I would like to avoid, since it is
	likely to cause problems some time in the future if somebody redesigns
	object memory allocation. This wrapper just makes it easy to find senders
	of calloc() in my code. -dtl"

	self returnTypeC: 'void *'.
	^ self cCode: 'malloc(size)'! !

!UnixOSProcessPlugin methodsFor: 'private' stamp: 'dtl 7/4/2001 22:53'!
transientCStringFromString: aString
	"Answer a new null-terminated C string copied from aString.
	The string is allocated in object memory, and will be moved
	without warning by the garbage collector. Any C pointer
	reference the the result is valid only until the garbage
	collector next runs. Therefore, this method should only be used
	within a single primitive in a section of code in which the
	garbage collector is guaranteed not to run. Note also that
	this method may itself invoke the garbage collector prior
	to allocating the new C string."

	| len stringPtr newString cString |
	self returnTypeC: 'char *'.
	self var: 'stringPtr' declareC: 'char *stringPtr'.
	self var: 'cString' declareC: 'char *cString'.

	len _ interpreterProxy sizeOfSTArrayFromCPrimitive: (interpreterProxy arrayValueOf: aString).
	stringPtr _ interpreterProxy arrayValueOf: aString.

	"Allocate space for a null terminated C string."
	newString _ interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len + 1.
	cString _ interpreterProxy arrayValueOf: newString.		"Point to the actual C string."
	self cCode: '(char *)strncpy(cString, stringPtr, len)'.		"Make a copy of the string."
	cString at: (len) put: 0.									"Null terminate the C string."
	^ cString
! !


!UnixOSProcessPlugin class methodsFor: 'translation' stamp: 'dtl 7/5/2001 22:56'!
declareCVarsIn: cg

	cg addHeaderFile: '<sys/types.h>
/* D T Lewis 2001 - ', self moduleName, '.c translated from class ', self name, ' */'.
	cg addHeaderFile: '<sys/time.h>'.
	cg addHeaderFile: '<sys/wait.h>'.
	cg addHeaderFile: '<signal.h>'.
	cg addHeaderFile: '<unistd.h>'.
	cg addHeaderFile: '<fcntl.h>'.
	cg addHeaderFile: '<sys/stat.h>'. "For stat(2) call in primitiveFileProtectionMask"
	cg addHeaderFile: '<errno.h>'.
	cg addHeaderFile: '<X11/Xlib.h>'.	"For access to Display in primitiveCanConnectToXDisplay"
	cg addHeaderFile: '"sq.h"'.
	cg addHeaderFile: '"FilePlugin.h"'.
	cg addHeaderFile: '"SocketPlugin.h"'
! !


!UnixProcess class methodsFor: 'X display' stamp: 'dtl 7/5/2001 23:21'!
canConnectToXDisplay: xDisplayName
	"Open and close a connection to displayName. It the connection was successfully
	opened, answer true; otherwise false. This is intended to check for the ability
	to open an X display prior to actually making the attempt."

	"UnixProcess canConnectToXDisplay: ':0.0' "
	"UnixProcess canConnectToXDisplay: ':1' "
	"UnixProcess canConnectToXDisplay: 'bogus:0' " "<-make sure network is running first!!"

	(xDisplayName isKindOf: String) ifFalse: [^ false].
	^ OSProcess accessor primCanConnectToXDisplay: xDisplayName
! !

!UnixProcess class methodsFor: 'X display' stamp: 'dtl 7/5/2001 22:37'!
currentXDisplayName

	"UnixProcess currentXDisplayName"

	^ OSProcess accessor primGetXDisplayName! !

!UnixProcess class methodsFor: 'X display' stamp: 'dtl 7/5/2001 23:31'!
displayOnXServer: xDisplayName
	"Check if it is possible to open a display on the X server identified by
	xDisplayName. If so, close the current X display and reopen it on
	the new server. On success, answer the previous display name. On
	failure, answer a string with an error message. This method is expected
	to be called by a web server or other application which may wish to
	make use of the result string."

	"UnixProcess displayOnXServer: 'unix:0' "
	"UnixProcess displayOnXServer: ':1' "

	| previousDisplayName |
	(xDisplayName isKindOf: String)
		ifFalse: [^ 'expected display name string'].
	previousDisplayName _ self currentXDisplayName.
	(self canConnectToXDisplay: xDisplayName)
		ifTrue:
			[self decapitate.
			self setXDisplayName: xDisplayName.
			self recapitate.
			^ previousDisplayName]
		ifFalse:
			[^ 'cannot connect to display ', xDisplayName]
! !

!UnixProcess class methodsFor: 'X display' stamp: 'dtl 7/5/2001 22:36'!
setXDisplayName: xDisplayName
	"Set X display name for use by the next call to recapitate"

	"UnixProcess setXDisplayName: 'unix:0' "
	"UnixProcess setXDisplayName: ':1' "

	OSProcess accessor primSetXDisplayName: xDisplayName

! !

UnixProcess class removeSelector: #currentDisplayName!
UnixOSProcessPlugin removeSelector: #callocWrapper:!
UnixOSProcessPlugin removeSelector: #isConnectedToXServer!
UnixOSProcessPlugin removeSelector: #primitiveGetDisplayName!
UnixOSProcessPlugin removeSelector: #primitivePutDisplayName!
UnixOSProcessPlugin removeSelector: #primitivePutXDisplayName!
UnixOSProcessAccessor removeSelector: #primIsConnectedToXDisplay!
